﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=12.2
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Dim selectedid As Int
 
	Private lstData As List					'Here to remember all values when rotating the device
	Private mapData As Map
	Private lstDeletedIds As List
	Private lstInitialData As List			'Declared here to remember your own data
	Private B4XSwitchAct_Value As Boolean
	Private LastItemBeingRemoved As Int
	Private InitialItemHeight As Int = 60dip
	Private modified As Boolean
End Sub


Sub Globals
	
	Private clv1 As CustomListView		'xCustomListView Library
	Private Label1 As Label				'Changed
	Private Button1 As Button
 
	Private xui As XUI						'XUI Views Library
	Private dragger As CLVDragger			'CLVDragger Class
	Private B4XSwitchActions As B4XSwitch	'XUI Views Library

	Private su As StringUtils				'StringUtils Library

End Sub


Sub Activity_Create(FirstTime As Boolean)
	
	Activity.LoadLayout("LayoutBase")
 
	clv1.DefaultTextBackgroundColor = 0xFF8F8F8F
	clv1.DefaultTextColor = xui.Color_White
	
	If FirstTime Then
		
		lstData.Initialize
		lstDeletedIds.Initialize
		lstInitialData.Initialize
		Private mapdata2 As Map
		
		modified = False
		
 
		
 		If CheckTableHasRows = True Then

			Dim cur As Cursor
			cur = Main.Data.ExecQuery("SELECT * FROM list order by id desc")
		
			For i = 0 To cur.RowCount - 1
				cur.Position = i
				
				Log("sqlite-id  "&cur.GetInt("id"))
 
					
				mapData.Initialize
				mapData.Put("id", cur.GetInt("id"))
				mapData.Put("line1", cur.GetString("line1"))		'To remember the order of the texts of the elements when rotating the device
				mapData.Put("line2", cur.GetString("line2"))
 
				lstData.Add(mapData) ' Add the new record to the list
				
				
				'We add it to another list to compare them when saving
				mapdata2.Initialize
				mapdata2.Put("id", cur.GetInt("id"))
				mapdata2.Put("line1", cur.GetString("line1"))
				mapData.Put("line2", cur.GetString("line2"))
 
				lstInitialData.Add(mapdata2)
			Next
			cur.Close
			
			
 		End If
		
 
	End If
	
		
	For i = 0 To lstData.Size - 1
		
		mapData = lstData.Get(i)
		Dim s As String = mapData.Get("line1")
		s = s.Replace("\nf#", CRLF)			'To control the multiline
		
		clv1.Add(CreateListItem(s, clv1.AsView.Width, InitialItemHeight), s)
		
		'We vary some heights:
		Dim pnl As B4XView = clv1.GetPanel(i)
		Private lbl As Label = pnl.GetView(0)
		lbl.Height = su.MeasureMultilineTextHeight(lbl,lbl.Text)

		clv1.ResizeItem(i, Max(lbl.Top+lbl.Height+25dip, InitialItemHeight))
		
		'We center the views:
		For Each v As View In pnl.GetAllViewsRecursive
			v.Top = (pnl.Height - v.Height) / 2
		Next
	Next

	
	dragger.Initialize(clv1, Me, "Dragger", lstData)
		
 
End Sub


Sub Activity_Resume
	
	B4XSwitchActions.Value = B4XSwitchAct_Value
	B4XSwitchActions_ValueChanged (B4XSwitchAct_Value)
	
 
End Sub


Sub Activity_Pause (UserClosed As Boolean)
	
	'New on version
	If clv1.Size = 0 Then Return
	
	'Return to left zero position
	Dim item As CLVItem = clv1.GetRawListItem(LastItemBeingRemoved)
	Dim p As Panel = item.Panel
	p.Left = 0
	
	'We return to establish the original border color
	Dim cdPanel As ColorDrawable
	cdPanel.Initialize2(xui.Color_Transparent,0,0,xui.Color_Black)
	p.GetView(0).Background = cdPanel
End Sub



Sub CreateListItem(Text1 As String, Width As Int, Height As Int) As Panel
	
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	p.LoadLayout("CellItem")
	Label1.Text = Text1
	Return p
End Sub


'Public Sub FontToBitmap (text1 As String, IsMaterialIcons As Boolean, FontSize As Float, color As Int) As B4XBitmap
'	
'	Dim xui As XUI
'	Dim p As Panel = xui.CreatePanel("")
'	p.SetLayoutAnimated(0, 0, 0, 32dip, 32dip)
'	Dim cvs1 As B4XCanvas
'	cvs1.Initialize(p)
'	Dim t As Typeface
'	If IsMaterialIcons Then t = Typeface.MATERIALICONS Else t = Typeface.FONTAWESOME
'	Dim fnt As B4XFont = xui.CreateFont(t, FontSize)
'	Dim r As B4XRect = cvs1.MeasureText(text1, fnt)
'	Dim BaseLine As Int = cvs1.TargetRect.CenterY - r.Height / 2 - r.Top
'	cvs1.DrawText(text1, cvs1.TargetRect.CenterX, BaseLine, fnt, color, "CENTER")
'	Dim b As B4XBitmap = cvs1.CreateBitmap
'	cvs1.Release
'	Return b
'End Sub


Sub Dragger_RemoveItem(Index As Int)
	
	LastItemBeingRemoved = Index
	
	Dim item As CLVItem = clv1.GetRawListItem(Index)
	Dim p As Panel = item.Panel
	
	Msgbox2Async("¿Are you sure you want to delete this item?", "Title", "Si", "", "No", Null, False)
	Wait For MsgBox_Result (Result As Int)
	If Result = DialogResponse.POSITIVE Then
				
		'We optionally animate the panel to the left so that the removal of the item is visible:
		Dim p As Panel = item.Panel
		p.SetLayoutAnimated(500, -300dip, p.Top, p.Width, p.Height)
		p.SetVisibleAnimated(500, False)
		Sleep(500)
		
		clv1.RemoveAt(Index)
		
		mapData = lstData.Get(Index)

		'We save the existing id that we have from the db
		If mapData.Get("id") > 0 Then lstDeletedIds.Add(mapData.Get("id"))
		
		'We reassign that id to the first record that is negative
		For Each record In lstData
		
			Dim mapa As Map = record
			If mapa.Get("id") < 0 Then
				
				If lstDeletedIds.Size > 0 Then
					mapa.Put("id", lstDeletedIds.Get(0))
					lstDeletedIds.RemoveAt(0)
					Exit
				End If
			End If
		Next
		
		lstData.RemoveAt(Index)
		
	Else

		p.SetLayoutAnimated(0, 0, p.Top, p.Width, p.Height)
		
		'We return to establish the original border color
		Dim cdPanel As ColorDrawable
		cdPanel.Initialize2(xui.Color_Transparent,0,0,xui.Color_Black)
		p.GetView(0).Background = cdPanel
	End If
End Sub

 

 

Sub CheckTableHasRows() As Boolean
	
	Dim CountRows As Int
	Dim SQLCmd As String
	SQLCmd = "SELECT COUNT(*) as rowcount FROM list"
	Dim cursor As Cursor
	cursor = Main.Data.ExecQuery(SQLCmd)
	If cursor.RowCount > 0 Then
		cursor.Position = 0
		CountRows = cursor.GetInt("rowcount")
	End If
	cursor.Close
'	Log(CountRows)
	If CountRows > 0 Then
		Return True  'Table has at least one record
	Else
		Return False 'Table has no records
	End If
End Sub

 


'CONTROLS:
Sub Clv1_ReachEnd
	
	Log("reach end")
 
End Sub


Sub Clv1_ItemClick (Index As Int, Value As Object)
	
 
	clv1.AsView.BringToFront
 
	Try
		
		Log("index "&Index)
		Log("value "&Value)
		
		 
		selectedid = Index + 1   
		
'		selectedid = (clv1.Size-Index)+2

		Log("clvsize "&clv1.Size)
		Log("id "&selectedid)
' 		show.id = Index
		StartActivity(show)
 
	Catch
		Log(LastException)
	End Try


End Sub


 


Sub B4XSwitchActions_ValueChanged (Value As Boolean)
	
	If Value Then
		dragger.SetDefaults(60dip, xui.Color_Black, xui.Color_White)
		dragger.AddDragButtons
	Else
		dragger.RemoveDragButtons
	End If
	
 
	B4XSwitchAct_Value = Value
End Sub

 


 

Private Sub lblSave_Click
	
	'Data before saving
	For Each record In lstData
		
		Dim mapa As Map = record
		
		For Each k As String In mapa.Keys
			Log(k & " = " & mapa.Get(k))
		Next
	Next
	
'	For Each record In lstInitialData
'		
'		Dim mapa As Map = record
'		
'		For Each k As String In mapa.Keys
'			Log(k & " = " & mapa.Get(k))
'		Next
'	Next
	
	
	'We compare the two lists to see if there have been any changes:
	If lstInitialData.Size <> lstData.Size Then
		modified = True
	Else
		
		Dim i As Int = 1
		For Each map1 As Map In lstData
			Dim map2 As Map : map2 = lstInitialData.Get(i - 1)
			
 
			If map1.Get("id") = map2.Get("id") And map1.Get("line1") = map2.Get("line1") And map1.Get("line2") = map2.Get("line2")  Then
				
			Else
'				Log("El Map " & i & " in both lists is different")
				modified = True
				Exit
			End If
			i = i + 1
		Next
	End If
	
	Log(modified)
	
	If modified = False Then
		ToastMessageShow("No changes to save", True)
		Return
	End If
	
	
	If modified = True Then
	
'		Private orderrow As Long
	
		For i = 0 To lstData.Size - 1
			
			Dim registro As Map = lstData.Get(i)
			Dim id As Long = registro.Get("id")
			Dim line1 As String = registro.Get("line1")
			Dim line2 As String = registro.Get("line2")
 

			If id > 0 Then	'Update existing record
				
				Dim strSQLUpdate As String
				strSQLUpdate = "UPDATE list SET line1=? , line2=? WHERE id=?"
				Main.data.ExecNonQuery2(strSQLUpdate, Array As Object(line1,line2, id))

			Else	'Insert a new record
				
				Dim strSQLInsert As String
				strSQLInsert = "INSERT INTO list (line1, line2) VALUES (?,?)"
				Main.Data.ExecNonQuery2(strSQLInsert, Array As Object(line1,line2))
			
				Dim newId As Int	'Variable to store the new id generated by the db
				Dim strSQLSelect As String	'SELECT query to get the id of the last inserted record
				strSQLSelect = "SELECT last_insert_rowid() AS newid"
			
				Dim cur As Cursor	'Cursor to store the result of the SELECT query
				cur = Main.Data.ExecQuery(strSQLSelect)
			
				If cur.RowCount > 0 Then
					cur.Position = 0
					newId = cur.GetInt("newid")
					Log(newId)
					
					registro.Put("id", newId)	'Assign the generated id to the map
					lstData.Set(i, registro)	'Update the map in its corresponding place in the list
				End If
			End If
		Next


		'Delete the corresponding records from the database
		'Build the string of comma-separated ids to execute in block
		Dim idsString As String
		For Each id1 As Long In lstDeletedIds
			If idsString = "" Then
				idsString = id1
			Else
				idsString = idsString & "," & id1
			End If
		Next
		
		Dim sql As String = "DELETE FROM list WHERE id IN (" & idsString & ")"
		Main.data.ExecNonQuery(sql)
	End If
	

	modified = False
	
	ToastMessageShow("Saved", False)
End Sub

 